/* MediaUpload.c generated by valac 0.56.3, the Vala compiler
 * generated from MediaUpload.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "cawbird.h"

#define TYPE_MEDIA_UPLOAD (media_upload_get_type ())
#define MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_UPLOAD, MediaUpload))
#define MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_UPLOAD, MediaUploadClass))
#define IS_MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_UPLOAD))
#define IS_MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_UPLOAD))
#define MEDIA_UPLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_UPLOAD, MediaUploadClass))

typedef struct _MediaUpload MediaUpload;
typedef struct _MediaUploadClass MediaUploadClass;
typedef struct _MediaUploadPrivate MediaUploadPrivate;
enum  {
	MEDIA_UPLOAD_0_PROPERTY,
	MEDIA_UPLOAD_ID_PROPERTY,
	MEDIA_UPLOAD_FILEPATH_PROPERTY,
	MEDIA_UPLOAD_FILETYPE_PROPERTY,
	MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY,
	MEDIA_UPLOAD_MEDIA_ID_PROPERTY,
	MEDIA_UPLOAD_FILESIZE_PROPERTY,
	MEDIA_UPLOAD_PROGRESS_PROPERTY,
	MEDIA_UPLOAD_CANCELLABLE_PROPERTY,
	MEDIA_UPLOAD_NUM_PROPERTIES
};
static GParamSpec* media_upload_properties[MEDIA_UPLOAD_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL,
	MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL,
	MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL,
	MEDIA_UPLOAD_NUM_SIGNALS
};
static guint media_upload_signals[MEDIA_UPLOAD_NUM_SIGNALS] = {0};

struct _MediaUpload {
	GObject parent_instance;
	MediaUploadPrivate * priv;
};

struct _MediaUploadClass {
	GObjectClass parent_class;
};

struct _MediaUploadPrivate {
	gchar* _id;
	gchar* cat;
	gint64 _media_id;
	GFile* file;
	GFileInfo* fileinfo;
	gboolean dm;
	gdouble _progress;
	gboolean upload_finalized;
	GCancellable* _cancellable;
};

static gint MediaUpload_private_offset;
static gpointer media_upload_parent_class = NULL;

VALA_EXTERN GType media_upload_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MediaUpload* media_upload_new (const gchar* filepath,
                               gboolean for_dm,
                               GError** error);
VALA_EXTERN MediaUpload* media_upload_construct (GType object_type,
                                     const gchar* filepath,
                                     gboolean for_dm,
                                     GError** error);
static void media_upload_set_id (MediaUpload* self,
                          const gchar* value);
static void media_upload_set_cancellable (MediaUpload* self,
                                   GCancellable* value);
VALA_EXTERN GFileInputStream* media_upload_read (MediaUpload* self,
                                     GError** error);
VALA_EXTERN void media_upload_finalize_upload (MediaUpload* self);
VALA_EXTERN void media_upload_set_progress (MediaUpload* self,
                                gdouble value);
VALA_EXTERN gboolean media_upload_is_uploaded (MediaUpload* self);
VALA_EXTERN const gchar* media_upload_get_id (MediaUpload* self);
VALA_EXTERN gchar* media_upload_get_filepath (MediaUpload* self);
VALA_EXTERN const gchar* media_upload_get_filetype (MediaUpload* self);
VALA_EXTERN gchar* media_upload_get_media_category (MediaUpload* self);
VALA_EXTERN gint64 media_upload_get_media_id (MediaUpload* self);
VALA_EXTERN void media_upload_set_media_id (MediaUpload* self,
                                gint64 value);
VALA_EXTERN gint64 media_upload_get_filesize (MediaUpload* self);
VALA_EXTERN gdouble media_upload_get_progress (MediaUpload* self);
VALA_EXTERN GCancellable* media_upload_get_cancellable (MediaUpload* self);
static void media_upload_finalize (GObject * obj);
static GType media_upload_get_type_once (void);
static void _vala_media_upload_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_media_upload_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
media_upload_get_instance_private (MediaUpload* self)
{
	return G_STRUCT_MEMBER_P (self, MediaUpload_private_offset);
}

MediaUpload*
media_upload_construct (GType object_type,
                        const gchar* filepath,
                        gboolean for_dm,
                        GError** error)
{
	MediaUpload * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
	GFileInfo* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 107 "../src/MediaUpload.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 107 "../src/MediaUpload.vala"
	self = (MediaUpload*) g_object_new (object_type, NULL);
#line 108 "../src/MediaUpload.vala"
	_tmp0_ = g_uuid_string_random ();
#line 108 "../src/MediaUpload.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/MediaUpload.vala"
	media_upload_set_id (self, _tmp1_);
#line 108 "../src/MediaUpload.vala"
	_g_free0 (_tmp1_);
#line 109 "../src/MediaUpload.vala"
	_tmp2_ = g_file_new_for_path (filepath);
#line 109 "../src/MediaUpload.vala"
	_g_object_unref0 (self->priv->file);
#line 109 "../src/MediaUpload.vala"
	self->priv->file = _tmp2_;
#line 110 "../src/MediaUpload.vala"
	_tmp4_ = self->priv->file;
#line 110 "../src/MediaUpload.vala"
	_tmp5_ = g_file_query_info (_tmp4_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE, 0, NULL, &_inner_error0_);
#line 110 "../src/MediaUpload.vala"
	_tmp3_ = _tmp5_;
#line 110 "../src/MediaUpload.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/MediaUpload.vala"
		g_propagate_error (error, _inner_error0_);
#line 110 "../src/MediaUpload.vala"
		_g_object_unref0 (self);
#line 110 "../src/MediaUpload.vala"
		return NULL;
#line 184 "MediaUpload.c"
	}
#line 110 "../src/MediaUpload.vala"
	_tmp6_ = _tmp3_;
#line 110 "../src/MediaUpload.vala"
	_tmp3_ = NULL;
#line 110 "../src/MediaUpload.vala"
	_g_object_unref0 (self->priv->fileinfo);
#line 110 "../src/MediaUpload.vala"
	self->priv->fileinfo = _tmp6_;
#line 113 "../src/MediaUpload.vala"
	self->priv->dm = for_dm;
#line 114 "../src/MediaUpload.vala"
	_tmp7_ = g_cancellable_new ();
#line 114 "../src/MediaUpload.vala"
	_tmp8_ = _tmp7_;
#line 114 "../src/MediaUpload.vala"
	media_upload_set_cancellable (self, _tmp8_);
#line 114 "../src/MediaUpload.vala"
	_g_object_unref0 (_tmp8_);
#line 107 "../src/MediaUpload.vala"
	_g_object_unref0 (_tmp3_);
#line 107 "../src/MediaUpload.vala"
	return self;
#line 208 "MediaUpload.c"
}

MediaUpload*
media_upload_new (const gchar* filepath,
                  gboolean for_dm,
                  GError** error)
{
#line 107 "../src/MediaUpload.vala"
	return media_upload_construct (TYPE_MEDIA_UPLOAD, filepath, for_dm, error);
#line 218 "MediaUpload.c"
}

GFileInputStream*
media_upload_read (MediaUpload* self,
                   GError** error)
{
	GFileInputStream* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileInputStream* _tmp2_;
	GFileInputStream* _tmp3_;
	GError* _inner_error0_ = NULL;
	GFileInputStream* result;
#line 117 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../src/MediaUpload.vala"
	_tmp1_ = self->priv->file;
#line 118 "../src/MediaUpload.vala"
	_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 118 "../src/MediaUpload.vala"
	_tmp0_ = _tmp2_;
#line 118 "../src/MediaUpload.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/MediaUpload.vala"
		g_propagate_error (error, _inner_error0_);
#line 118 "../src/MediaUpload.vala"
		return NULL;
#line 245 "MediaUpload.c"
	}
#line 118 "../src/MediaUpload.vala"
	_tmp3_ = _tmp0_;
#line 118 "../src/MediaUpload.vala"
	_tmp0_ = NULL;
#line 118 "../src/MediaUpload.vala"
	result = _tmp3_;
#line 118 "../src/MediaUpload.vala"
	_g_object_unref0 (_tmp0_);
#line 118 "../src/MediaUpload.vala"
	return result;
#line 257 "MediaUpload.c"
}

void
media_upload_finalize_upload (MediaUpload* self)
{
#line 121 "../src/MediaUpload.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/MediaUpload.vala"
	g_debug ("MediaUpload.vala:122: Finalizing upload");
#line 123 "../src/MediaUpload.vala"
	media_upload_set_progress (self, 1.0);
#line 124 "../src/MediaUpload.vala"
	self->priv->upload_finalized = TRUE;
#line 125 "../src/MediaUpload.vala"
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL], 0, NULL);
#line 273 "MediaUpload.c"
}

gboolean
media_upload_is_uploaded (MediaUpload* self)
{
	gboolean result;
#line 128 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../src/MediaUpload.vala"
	result = self->priv->upload_finalized;
#line 129 "../src/MediaUpload.vala"
	return result;
#line 286 "MediaUpload.c"
}

const gchar*
media_upload_get_id (MediaUpload* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 19 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->_id;
#line 19 "../src/MediaUpload.vala"
	result = _tmp0_;
#line 19 "../src/MediaUpload.vala"
	return result;
#line 302 "MediaUpload.c"
}

static void
media_upload_set_id (MediaUpload* self,
                     const gchar* value)
{
	gchar* old_value;
#line 19 "../src/MediaUpload.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/MediaUpload.vala"
	old_value = media_upload_get_id (self);
#line 19 "../src/MediaUpload.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 316 "MediaUpload.c"
		gchar* _tmp0_;
#line 19 "../src/MediaUpload.vala"
		_tmp0_ = g_strdup (value);
#line 19 "../src/MediaUpload.vala"
		_g_free0 (self->priv->_id);
#line 19 "../src/MediaUpload.vala"
		self->priv->_id = _tmp0_;
#line 19 "../src/MediaUpload.vala"
		g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_ID_PROPERTY]);
#line 326 "MediaUpload.c"
	}
}

gchar*
media_upload_get_filepath (MediaUpload* self)
{
	gchar* result;
	GFile* _tmp0_;
	gchar* _tmp1_;
#line 21 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->file;
#line 22 "../src/MediaUpload.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 22 "../src/MediaUpload.vala"
	result = _tmp1_;
#line 22 "../src/MediaUpload.vala"
	return result;
#line 346 "MediaUpload.c"
}

const gchar*
media_upload_get_filetype (MediaUpload* self)
{
	const gchar* result;
	GFileInfo* _tmp0_;
	const gchar* _tmp1_;
#line 26 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->fileinfo;
#line 47 "../src/MediaUpload.vala"
	_tmp1_ = g_file_info_get_content_type (_tmp0_);
#line 47 "../src/MediaUpload.vala"
	result = _tmp1_;
#line 47 "../src/MediaUpload.vala"
	return result;
#line 365 "MediaUpload.c"
}

gchar*
media_upload_get_media_category (MediaUpload* self)
{
	gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
#line 53 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->cat;
#line 54 "../src/MediaUpload.vala"
	if (_tmp0_ == NULL) {
#line 381 "MediaUpload.c"
		const gchar* _tmp1_ = NULL;
		gchar* prefix = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 55 "../src/MediaUpload.vala"
		if (self->priv->dm) {
#line 55 "../src/MediaUpload.vala"
			_tmp1_ = "dm";
#line 391 "MediaUpload.c"
		} else {
#line 55 "../src/MediaUpload.vala"
			_tmp1_ = "tweet";
#line 395 "MediaUpload.c"
		}
#line 55 "../src/MediaUpload.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 55 "../src/MediaUpload.vala"
		prefix = _tmp2_;
#line 56 "../src/MediaUpload.vala"
		_tmp3_ = media_upload_get_filetype (self);
#line 56 "../src/MediaUpload.vala"
		_tmp4_ = _tmp3_;
#line 56 "../src/MediaUpload.vala"
		if (g_str_has_prefix (_tmp4_, "video/")) {
#line 407 "MediaUpload.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 57 "../src/MediaUpload.vala"
			_tmp5_ = prefix;
#line 57 "../src/MediaUpload.vala"
			_tmp6_ = g_strdup_printf ("%s_video", _tmp5_);
#line 57 "../src/MediaUpload.vala"
			_g_free0 (self->priv->cat);
#line 57 "../src/MediaUpload.vala"
			self->priv->cat = _tmp6_;
#line 418 "MediaUpload.c"
		} else {
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 59 "../src/MediaUpload.vala"
			_tmp7_ = media_upload_get_filetype (self);
#line 59 "../src/MediaUpload.vala"
			_tmp8_ = _tmp7_;
#line 59 "../src/MediaUpload.vala"
			if (g_strcmp0 (_tmp8_, "image/gif") == 0) {
#line 428 "MediaUpload.c"
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_;
#line 61 "../src/MediaUpload.vala"
				_tmp9_ = media_upload_get_filepath (self);
#line 61 "../src/MediaUpload.vala"
				_tmp10_ = _tmp9_;
#line 61 "../src/MediaUpload.vala"
				_tmp11_ = _tmp10_;
#line 61 "../src/MediaUpload.vala"
				_tmp12_ = utils_is_animated_gif (_tmp11_);
#line 61 "../src/MediaUpload.vala"
				_g_free0 (_tmp11_);
#line 61 "../src/MediaUpload.vala"
				if (_tmp12_) {
#line 445 "MediaUpload.c"
					const gchar* _tmp13_;
					gchar* _tmp14_;
#line 62 "../src/MediaUpload.vala"
					_tmp13_ = prefix;
#line 62 "../src/MediaUpload.vala"
					_tmp14_ = g_strdup_printf ("%s_gif", _tmp13_);
#line 62 "../src/MediaUpload.vala"
					_g_free0 (self->priv->cat);
#line 62 "../src/MediaUpload.vala"
					self->priv->cat = _tmp14_;
#line 456 "MediaUpload.c"
				} else {
					const gchar* _tmp15_;
					gchar* _tmp16_;
#line 65 "../src/MediaUpload.vala"
					_tmp15_ = prefix;
#line 65 "../src/MediaUpload.vala"
					_tmp16_ = g_strdup_printf ("%s_image", _tmp15_);
#line 65 "../src/MediaUpload.vala"
					_g_free0 (self->priv->cat);
#line 65 "../src/MediaUpload.vala"
					self->priv->cat = _tmp16_;
#line 468 "MediaUpload.c"
				}
			} else {
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 69 "../src/MediaUpload.vala"
				_tmp17_ = prefix;
#line 69 "../src/MediaUpload.vala"
				_tmp18_ = g_strdup_printf ("%s_image", _tmp17_);
#line 69 "../src/MediaUpload.vala"
				_g_free0 (self->priv->cat);
#line 69 "../src/MediaUpload.vala"
				self->priv->cat = _tmp18_;
#line 481 "MediaUpload.c"
			}
		}
#line 54 "../src/MediaUpload.vala"
		_g_free0 (prefix);
#line 486 "MediaUpload.c"
	}
#line 72 "../src/MediaUpload.vala"
	_tmp19_ = self->priv->cat;
#line 72 "../src/MediaUpload.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 72 "../src/MediaUpload.vala"
	result = _tmp20_;
#line 72 "../src/MediaUpload.vala"
	return result;
#line 496 "MediaUpload.c"
}

gint64
media_upload_get_media_id (MediaUpload* self)
{
	gint64 result;
#line 77 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 77 "../src/MediaUpload.vala"
	result = self->priv->_media_id;
#line 77 "../src/MediaUpload.vala"
	return result;
#line 509 "MediaUpload.c"
}

void
media_upload_set_media_id (MediaUpload* self,
                           gint64 value)
{
#line 78 "../src/MediaUpload.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/MediaUpload.vala"
	self->priv->_media_id = value;
#line 80 "../src/MediaUpload.vala"
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL], 0);
#line 78 "../src/MediaUpload.vala"
	g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_MEDIA_ID_PROPERTY]);
#line 524 "MediaUpload.c"
}

gint64
media_upload_get_filesize (MediaUpload* self)
{
	gint64 result;
	GFileInfo* _tmp0_;
#line 87 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 88 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->fileinfo;
#line 88 "../src/MediaUpload.vala"
	result = g_file_info_get_size (_tmp0_);
#line 88 "../src/MediaUpload.vala"
	return result;
#line 540 "MediaUpload.c"
}

gdouble
media_upload_get_progress (MediaUpload* self)
{
	gdouble result;
#line 93 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 94 "../src/MediaUpload.vala"
	result = self->priv->_progress;
#line 94 "../src/MediaUpload.vala"
	return result;
#line 553 "MediaUpload.c"
}

void
media_upload_set_progress (MediaUpload* self,
                           gdouble value)
{
#line 96 "../src/MediaUpload.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/MediaUpload.vala"
	self->priv->_progress = value;
#line 98 "../src/MediaUpload.vala"
	g_signal_emit (self, media_upload_signals[MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL], 0, self->priv->_progress);
#line 96 "../src/MediaUpload.vala"
	g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_PROGRESS_PROPERTY]);
#line 568 "MediaUpload.c"
}

GCancellable*
media_upload_get_cancellable (MediaUpload* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
#line 102 "../src/MediaUpload.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/MediaUpload.vala"
	_tmp0_ = self->priv->_cancellable;
#line 102 "../src/MediaUpload.vala"
	result = _tmp0_;
#line 102 "../src/MediaUpload.vala"
	return result;
#line 584 "MediaUpload.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "../src/MediaUpload.vala"
	return self ? g_object_ref (self) : NULL;
#line 592 "MediaUpload.c"
}

static void
media_upload_set_cancellable (MediaUpload* self,
                              GCancellable* value)
{
	GCancellable* old_value;
#line 102 "../src/MediaUpload.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/MediaUpload.vala"
	old_value = media_upload_get_cancellable (self);
#line 102 "../src/MediaUpload.vala"
	if (old_value != value) {
#line 606 "MediaUpload.c"
		GCancellable* _tmp0_;
#line 102 "../src/MediaUpload.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 102 "../src/MediaUpload.vala"
		_g_object_unref0 (self->priv->_cancellable);
#line 102 "../src/MediaUpload.vala"
		self->priv->_cancellable = _tmp0_;
#line 102 "../src/MediaUpload.vala"
		g_object_notify_by_pspec ((GObject *) self, media_upload_properties[MEDIA_UPLOAD_CANCELLABLE_PROPERTY]);
#line 616 "MediaUpload.c"
	}
}

static void
media_upload_class_init (MediaUploadClass * klass,
                         gpointer klass_data)
{
#line 18 "../src/MediaUpload.vala"
	media_upload_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/MediaUpload.vala"
	g_type_class_adjust_private_offset (klass, &MediaUpload_private_offset);
#line 18 "../src/MediaUpload.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_media_upload_get_property;
#line 18 "../src/MediaUpload.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_media_upload_set_property;
#line 18 "../src/MediaUpload.vala"
	G_OBJECT_CLASS (klass)->finalize = media_upload_finalize;
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_ID_PROPERTY, media_upload_properties[MEDIA_UPLOAD_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILEPATH_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILEPATH_PROPERTY] = g_param_spec_string ("filepath", "filepath", "filepath", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILETYPE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILETYPE_PROPERTY] = g_param_spec_string ("filetype", "filetype", "filetype", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY, media_upload_properties[MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY] = g_param_spec_string ("media-category", "media-category", "media-category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_MEDIA_ID_PROPERTY, media_upload_properties[MEDIA_UPLOAD_MEDIA_ID_PROPERTY] = g_param_spec_int64 ("media-id", "media-id", "media-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_FILESIZE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_FILESIZE_PROPERTY] = g_param_spec_int64 ("filesize", "filesize", "filesize", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_PROGRESS_PROPERTY, media_upload_properties[MEDIA_UPLOAD_PROGRESS_PROPERTY] = g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/MediaUpload.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_UPLOAD_CANCELLABLE_PROPERTY, media_upload_properties[MEDIA_UPLOAD_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/MediaUpload.vala"
	media_upload_signals[MEDIA_UPLOAD_PROGRESS_UPDATED_SIGNAL] = g_signal_new ("progress-updated", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 18 "../src/MediaUpload.vala"
	media_upload_signals[MEDIA_UPLOAD_PROGRESS_COMPLETE_SIGNAL] = g_signal_new ("progress-complete", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 18 "../src/MediaUpload.vala"
	media_upload_signals[MEDIA_UPLOAD_MEDIA_ID_ASSIGNED_SIGNAL] = g_signal_new ("media-id-assigned", TYPE_MEDIA_UPLOAD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 656 "MediaUpload.c"
}

static void
media_upload_instance_init (MediaUpload * self,
                            gpointer klass)
{
#line 18 "../src/MediaUpload.vala"
	self->priv = media_upload_get_instance_private (self);
#line 75 "../src/MediaUpload.vala"
	self->priv->_media_id = (gint64) -1;
#line 91 "../src/MediaUpload.vala"
	self->priv->_progress = (gdouble) 0;
#line 669 "MediaUpload.c"
}

static void
media_upload_finalize (GObject * obj)
{
	MediaUpload * self;
#line 18 "../src/MediaUpload.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_UPLOAD, MediaUpload);
#line 19 "../src/MediaUpload.vala"
	_g_free0 (self->priv->_id);
#line 51 "../src/MediaUpload.vala"
	_g_free0 (self->priv->cat);
#line 83 "../src/MediaUpload.vala"
	_g_object_unref0 (self->priv->file);
#line 84 "../src/MediaUpload.vala"
	_g_object_unref0 (self->priv->fileinfo);
#line 102 "../src/MediaUpload.vala"
	_g_object_unref0 (self->priv->_cancellable);
#line 18 "../src/MediaUpload.vala"
	G_OBJECT_CLASS (media_upload_parent_class)->finalize (obj);
#line 690 "MediaUpload.c"
}

static GType
media_upload_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaUploadClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_upload_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaUpload), 0, (GInstanceInitFunc) media_upload_instance_init, NULL };
	GType media_upload_type_id;
	media_upload_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaUpload", &g_define_type_info, 0);
	MediaUpload_private_offset = g_type_add_instance_private (media_upload_type_id, sizeof (MediaUploadPrivate));
	return media_upload_type_id;
}

GType
media_upload_get_type (void)
{
	static volatile gsize media_upload_type_id__once = 0;
	if (g_once_init_enter (&media_upload_type_id__once)) {
		GType media_upload_type_id;
		media_upload_type_id = media_upload_get_type_once ();
		g_once_init_leave (&media_upload_type_id__once, media_upload_type_id);
	}
	return media_upload_type_id__once;
}

static void
_vala_media_upload_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MediaUpload * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_UPLOAD, MediaUpload);
#line 18 "../src/MediaUpload.vala"
	switch (property_id) {
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_ID_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_string (value, media_upload_get_id (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_FILEPATH_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_take_string (value, media_upload_get_filepath (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_FILETYPE_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_string (value, media_upload_get_filetype (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_MEDIA_CATEGORY_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_take_string (value, media_upload_get_media_category (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_MEDIA_ID_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_int64 (value, media_upload_get_media_id (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_FILESIZE_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_int64 (value, media_upload_get_filesize (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_PROGRESS_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_double (value, media_upload_get_progress (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_CANCELLABLE_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		g_value_set_object (value, media_upload_get_cancellable (self));
#line 18 "../src/MediaUpload.vala"
		break;
#line 773 "MediaUpload.c"
		default:
#line 18 "../src/MediaUpload.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/MediaUpload.vala"
		break;
#line 779 "MediaUpload.c"
	}
}

static void
_vala_media_upload_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MediaUpload * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_UPLOAD, MediaUpload);
#line 18 "../src/MediaUpload.vala"
	switch (property_id) {
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_ID_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		media_upload_set_id (self, g_value_get_string (value));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_MEDIA_ID_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		media_upload_set_media_id (self, g_value_get_int64 (value));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_PROGRESS_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		media_upload_set_progress (self, g_value_get_double (value));
#line 18 "../src/MediaUpload.vala"
		break;
#line 18 "../src/MediaUpload.vala"
		case MEDIA_UPLOAD_CANCELLABLE_PROPERTY:
#line 18 "../src/MediaUpload.vala"
		media_upload_set_cancellable (self, g_value_get_object (value));
#line 18 "../src/MediaUpload.vala"
		break;
#line 817 "MediaUpload.c"
		default:
#line 18 "../src/MediaUpload.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/MediaUpload.vala"
		break;
#line 823 "MediaUpload.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

