/* Settings.c generated by valac 0.56.3, the Vala compiler
 * generated from Settings.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include "CbTextTransform.h"
#include <glib-object.h>

enum  {
	SETTINGS_0_PROPERTY,
	SETTINGS_NUM_PROPERTIES
};
static GParamSpec* settings_properties[SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer settings_parent_class = NULL;
static GSettings* settings_settings;
static GSettings* settings_settings = NULL;

static void settings_finalize (GObject * obj);
static GType settings_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
media_visibility_get_type_once (void)
{
	static const GEnumValue values[] = {{MEDIA_VISIBILITY_SHOW, "MEDIA_VISIBILITY_SHOW", "show"}, {MEDIA_VISIBILITY_HIDE, "MEDIA_VISIBILITY_HIDE", "hide"}, {MEDIA_VISIBILITY_HIDE_IN_TIMELINES, "MEDIA_VISIBILITY_HIDE_IN_TIMELINES", "hide-in-timelines"}, {0, NULL, NULL}};
	GType media_visibility_type_id;
	media_visibility_type_id = g_enum_register_static ("MediaVisibility", values);
	return media_visibility_type_id;
}

GType
media_visibility_get_type (void)
{
	static volatile gsize media_visibility_type_id__once = 0;
	if (g_once_init_enter (&media_visibility_type_id__once)) {
		GType media_visibility_type_id;
		media_visibility_type_id = media_visibility_get_type_once ();
		g_once_init_leave (&media_visibility_type_id__once, media_visibility_type_id);
	}
	return media_visibility_type_id__once;
}

static GType
translation_service_get_type_once (void)
{
	static const GEnumValue values[] = {{TRANSLATION_SERVICE_GOOGLE, "TRANSLATION_SERVICE_GOOGLE", "google"}, {TRANSLATION_SERVICE_BING, "TRANSLATION_SERVICE_BING", "bing"}, {TRANSLATION_SERVICE_DEEPL, "TRANSLATION_SERVICE_DEEPL", "deepl"}, {TRANSLATION_SERVICE_CUSTOM, "TRANSLATION_SERVICE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType translation_service_type_id;
	translation_service_type_id = g_enum_register_static ("TranslationService", values);
	return translation_service_type_id;
}

GType
translation_service_get_type (void)
{
	static volatile gsize translation_service_type_id__once = 0;
	if (g_once_init_enter (&translation_service_type_id__once)) {
		GType translation_service_type_id;
		translation_service_type_id = translation_service_get_type_once ();
		g_once_init_leave (&translation_service_type_id__once, translation_service_type_id);
	}
	return translation_service_type_id__once;
}

static GType
shortcut_key_get_type_once (void)
{
	static const GEnumValue values[] = {{SHORTCUT_KEY_ALT, "SHORTCUT_KEY_ALT", "alt"}, {SHORTCUT_KEY_CTRL, "SHORTCUT_KEY_CTRL", "ctrl"}, {SHORTCUT_KEY_SHIFT, "SHORTCUT_KEY_SHIFT", "shift"}, {SHORTCUT_KEY_SUPER, "SHORTCUT_KEY_SUPER", "super"}, {SHORTCUT_KEY_PRIMARY, "SHORTCUT_KEY_PRIMARY", "primary"}, {0, NULL, NULL}};
	GType shortcut_key_type_id;
	shortcut_key_type_id = g_enum_register_static ("ShortcutKey", values);
	return shortcut_key_type_id;
}

GType
shortcut_key_get_type (void)
{
	static volatile gsize shortcut_key_type_id__once = 0;
	if (g_once_init_enter (&shortcut_key_type_id__once)) {
		GType shortcut_key_type_id;
		shortcut_key_type_id = shortcut_key_get_type_once ();
		g_once_init_leave (&shortcut_key_type_id__once, shortcut_key_type_id);
	}
	return shortcut_key_type_id__once;
}

void
settings_init (void)
{
	GSettings* _tmp0_;
#line 43 "../src/Settings.vala"
	_tmp0_ = g_settings_new ("uk.co.ibboard.cawbird");
#line 43 "../src/Settings.vala"
	_g_object_unref0 (settings_settings);
#line 43 "../src/Settings.vala"
	settings_settings = _tmp0_;
#line 123 "Settings.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 131 "Settings.c"
}

GSettings*
settings_get (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* result;
#line 47 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 47 "../src/Settings.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 47 "../src/Settings.vala"
	result = _tmp1_;
#line 47 "../src/Settings.vala"
	return result;
#line 148 "Settings.c"
}

/**
   * Returns how many tweets should be stacked before a
   * notification should be created.
   */
gint
settings_get_tweet_stack_count (void)
{
	gint setting_val = 0;
	GSettings* _tmp0_;
	gint result;
#line 55 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 55 "../src/Settings.vala"
	setting_val = g_settings_get_enum (_tmp0_, "new-tweets-notify");
#line 56 "../src/Settings.vala"
	result = setting_val;
#line 56 "../src/Settings.vala"
	return result;
#line 169 "Settings.c"
}

/**
  * Check whether the user wants Cawbird to always use the dark gtk theme variant.
  */
gboolean
settings_use_dark_theme (void)
{
	GSettings* _tmp0_;
	gboolean result;
#line 63 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 63 "../src/Settings.vala"
	result = g_settings_get_boolean (_tmp0_, "use-dark-theme");
#line 63 "../src/Settings.vala"
	return result;
#line 186 "Settings.c"
}

gboolean
settings_notify_new_mentions (void)
{
	GSettings* _tmp0_;
	gboolean result;
#line 67 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 67 "../src/Settings.vala"
	result = g_settings_get_boolean (_tmp0_, "new-mentions-notify");
#line 67 "../src/Settings.vala"
	return result;
#line 200 "Settings.c"
}

gboolean
settings_notify_new_dms (void)
{
	GSettings* _tmp0_;
	gboolean result;
#line 71 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 71 "../src/Settings.vala"
	result = g_settings_get_boolean (_tmp0_, "new-dms-notify");
#line 71 "../src/Settings.vala"
	return result;
#line 214 "Settings.c"
}

gboolean
settings_auto_scroll_on_new_tweets (void)
{
	GSettings* _tmp0_;
	gboolean result;
#line 75 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 75 "../src/Settings.vala"
	result = g_settings_get_boolean (_tmp0_, "auto-scroll-on-new-tweets");
#line 75 "../src/Settings.vala"
	return result;
#line 228 "Settings.c"
}

gchar*
settings_get_accel (const gchar* accel_name)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 78 "../src/Settings.vala"
	g_return_val_if_fail (accel_name != NULL, NULL);
#line 79 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 79 "../src/Settings.vala"
	_tmp1_ = g_strconcat ("accel-", accel_name, NULL);
#line 79 "../src/Settings.vala"
	_tmp2_ = _tmp1_;
#line 79 "../src/Settings.vala"
	_tmp3_ = g_settings_get_string (_tmp0_, _tmp2_);
#line 79 "../src/Settings.vala"
	_tmp4_ = _tmp3_;
#line 79 "../src/Settings.vala"
	_g_free0 (_tmp2_);
#line 79 "../src/Settings.vala"
	result = _tmp4_;
#line 79 "../src/Settings.vala"
	return result;
#line 258 "Settings.c"
}

gdouble
settings_get_tweet_scale (void)
{
	gint scale_idx = 0;
	GSettings* _tmp0_;
	gdouble result;
#line 83 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 83 "../src/Settings.vala"
	scale_idx = g_settings_get_enum (_tmp0_, "tweet-scale");
#line 84 "../src/Settings.vala"
	switch (scale_idx) {
#line 84 "../src/Settings.vala"
		case 3:
#line 275 "Settings.c"
		{
#line 85 "../src/Settings.vala"
			result = PANGO_SCALE_XX_LARGE;
#line 85 "../src/Settings.vala"
			return result;
#line 281 "Settings.c"
		}
#line 84 "../src/Settings.vala"
		case 2:
#line 285 "Settings.c"
		{
#line 86 "../src/Settings.vala"
			result = PANGO_SCALE_X_LARGE;
#line 86 "../src/Settings.vala"
			return result;
#line 291 "Settings.c"
		}
#line 84 "../src/Settings.vala"
		case 1:
#line 295 "Settings.c"
		{
#line 87 "../src/Settings.vala"
			result = PANGO_SCALE_LARGE;
#line 87 "../src/Settings.vala"
			return result;
#line 301 "Settings.c"
		}
		default:
		{
#line 88 "../src/Settings.vala"
			result = PANGO_SCALE_MEDIUM;
#line 88 "../src/Settings.vala"
			return result;
#line 309 "Settings.c"
		}
	}
}

void
settings_toggle_topbar_visible (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 93 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 93 "../src/Settings.vala"
	_tmp1_ = settings_settings;
#line 93 "../src/Settings.vala"
	g_settings_set_boolean (_tmp0_, "sidebar-visible", !g_settings_get_boolean (_tmp1_, "sidebar-visible"));
#line 325 "Settings.c"
}

gchar*
settings_get_consumer_key (const gchar* default_key)
{
	gchar* override_key = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp5_;
	gchar* result;
#line 96 "../src/Settings.vala"
	g_return_val_if_fail (default_key != NULL, NULL);
#line 97 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 97 "../src/Settings.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-key");
#line 97 "../src/Settings.vala"
	override_key = _tmp1_;
#line 98 "../src/Settings.vala"
	_tmp3_ = override_key;
#line 98 "../src/Settings.vala"
	if (g_strcmp0 (_tmp3_, "") != 0) {
#line 350 "Settings.c"
		const gchar* _tmp4_;
#line 98 "../src/Settings.vala"
		_tmp4_ = override_key;
#line 98 "../src/Settings.vala"
		_tmp2_ = _tmp4_;
#line 356 "Settings.c"
	} else {
#line 98 "../src/Settings.vala"
		_tmp2_ = default_key;
#line 360 "Settings.c"
	}
#line 98 "../src/Settings.vala"
	_tmp5_ = g_strdup (_tmp2_);
#line 98 "../src/Settings.vala"
	result = _tmp5_;
#line 98 "../src/Settings.vala"
	_g_free0 (override_key);
#line 98 "../src/Settings.vala"
	return result;
#line 370 "Settings.c"
}

gchar*
settings_get_consumer_secret (const gchar* default_secret)
{
	gchar* override_secret = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp5_;
	gchar* result;
#line 101 "../src/Settings.vala"
	g_return_val_if_fail (default_secret != NULL, NULL);
#line 102 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 102 "../src/Settings.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-secret");
#line 102 "../src/Settings.vala"
	override_secret = _tmp1_;
#line 103 "../src/Settings.vala"
	_tmp3_ = override_secret;
#line 103 "../src/Settings.vala"
	if (g_strcmp0 (_tmp3_, "") != 0) {
#line 395 "Settings.c"
		const gchar* _tmp4_;
#line 103 "../src/Settings.vala"
		_tmp4_ = override_secret;
#line 103 "../src/Settings.vala"
		_tmp2_ = _tmp4_;
#line 401 "Settings.c"
	} else {
#line 103 "../src/Settings.vala"
		_tmp2_ = default_secret;
#line 405 "Settings.c"
	}
#line 103 "../src/Settings.vala"
	_tmp5_ = g_strdup (_tmp2_);
#line 103 "../src/Settings.vala"
	result = _tmp5_;
#line 103 "../src/Settings.vala"
	_g_free0 (override_secret);
#line 103 "../src/Settings.vala"
	return result;
#line 415 "Settings.c"
}

void
settings_add_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 107 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 107 "../src/Settings.vala"
	_tmp1_ = settings_settings;
#line 107 "../src/Settings.vala"
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") | flag);
#line 429 "Settings.c"
}

void
settings_remove_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 112 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 112 "../src/Settings.vala"
	_tmp1_ = settings_settings;
#line 112 "../src/Settings.vala"
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") & (~flag));
#line 443 "Settings.c"
}

CbTransformFlags
settings_get_text_transform_flags (void)
{
	GSettings* _tmp0_;
	CbTransformFlags result;
#line 117 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 117 "../src/Settings.vala"
	result = (CbTransformFlags) g_settings_get_uint (_tmp0_, "text-transform-flags");
#line 117 "../src/Settings.vala"
	return result;
#line 457 "Settings.c"
}

gboolean
settings_hide_nsfw_content (void)
{
	GSettings* _tmp0_;
	gboolean result;
#line 121 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 121 "../src/Settings.vala"
	result = g_settings_get_boolean (_tmp0_, "hide-nsfw-content");
#line 121 "../src/Settings.vala"
	return result;
#line 471 "Settings.c"
}

MediaVisibility
settings_get_media_visiblity (void)
{
	GSettings* _tmp0_;
	MediaVisibility result;
#line 125 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 125 "../src/Settings.vala"
	result = (MediaVisibility) g_settings_get_enum (_tmp0_, "media-visibility");
#line 125 "../src/Settings.vala"
	return result;
#line 485 "Settings.c"
}

TranslationService
settings_get_translation_service (void)
{
	GSettings* _tmp0_;
	TranslationService result;
#line 129 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 129 "../src/Settings.vala"
	result = (TranslationService) g_settings_get_enum (_tmp0_, "translation-service");
#line 129 "../src/Settings.vala"
	return result;
#line 499 "Settings.c"
}

gchar*
settings_get_custom_translation_service (void)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 133 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 133 "../src/Settings.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "custom-translation-service");
#line 133 "../src/Settings.vala"
	result = _tmp1_;
#line 133 "../src/Settings.vala"
	return result;
#line 516 "Settings.c"
}

void
settings_set_custom_translation_service (const gchar* new_url)
{
	GSettings* _tmp0_;
#line 136 "../src/Settings.vala"
	g_return_if_fail (new_url != NULL);
#line 138 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 138 "../src/Settings.vala"
	g_settings_set_string (_tmp0_, "custom-translation-service", new_url);
#line 529 "Settings.c"
}

gchar*
settings_get_translation_service_url (void)
{
	TranslationService translation_service = 0;
	gchar* result;
#line 142 "../src/Settings.vala"
	translation_service = settings_get_translation_service ();
#line 143 "../src/Settings.vala"
	switch (translation_service) {
#line 143 "../src/Settings.vala"
		case TRANSLATION_SERVICE_GOOGLE:
#line 543 "Settings.c"
		{
			gchar* _tmp0_;
#line 145 "../src/Settings.vala"
			_tmp0_ = g_strdup ("https://translate.google.com/?op=translate&sl={SOURCE_LANG}&tl={TARGET" \
"_LANG}&text={CONTENT}");
#line 145 "../src/Settings.vala"
			result = _tmp0_;
#line 145 "../src/Settings.vala"
			return result;
#line 552 "Settings.c"
		}
#line 143 "../src/Settings.vala"
		case TRANSLATION_SERVICE_BING:
#line 556 "Settings.c"
		{
			gchar* _tmp1_;
#line 147 "../src/Settings.vala"
			_tmp1_ = g_strdup ("https://www.bing.com/translator/?from={SOURCE_LANG}&to={TARGET_LANG}&t" \
"ext={CONTENT}");
#line 147 "../src/Settings.vala"
			result = _tmp1_;
#line 147 "../src/Settings.vala"
			return result;
#line 565 "Settings.c"
		}
#line 143 "../src/Settings.vala"
		case TRANSLATION_SERVICE_DEEPL:
#line 569 "Settings.c"
		{
			gchar* _tmp2_;
#line 149 "../src/Settings.vala"
			_tmp2_ = g_strdup ("https://www.deepl.com/translator#{SOURCE_LANG}/{TARGET_LANG}/{CONTENT}");
#line 149 "../src/Settings.vala"
			result = _tmp2_;
#line 149 "../src/Settings.vala"
			return result;
#line 578 "Settings.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 151 "../src/Settings.vala"
			_tmp3_ = settings_get_custom_translation_service ();
#line 151 "../src/Settings.vala"
			result = _tmp3_;
#line 151 "../src/Settings.vala"
			return result;
#line 589 "Settings.c"
		}
	}
}

ShortcutKey
settings_get_shortcut_key (void)
{
	GSettings* _tmp0_;
	ShortcutKey result;
#line 156 "../src/Settings.vala"
	_tmp0_ = settings_settings;
#line 156 "../src/Settings.vala"
	result = (ShortcutKey) g_settings_get_enum (_tmp0_, "shortcut-key");
#line 156 "../src/Settings.vala"
	return result;
#line 605 "Settings.c"
}

gchar*
settings_get_shortcut_key_string (void)
{
	ShortcutKey shortcut_key = 0;
	gchar* result;
#line 160 "../src/Settings.vala"
	shortcut_key = settings_get_shortcut_key ();
#line 161 "../src/Settings.vala"
	switch (shortcut_key) {
#line 161 "../src/Settings.vala"
		case SHORTCUT_KEY_ALT:
#line 619 "Settings.c"
		{
			gchar* _tmp0_;
#line 163 "../src/Settings.vala"
			_tmp0_ = g_strdup ("<ALT>");
#line 163 "../src/Settings.vala"
			result = _tmp0_;
#line 163 "../src/Settings.vala"
			return result;
#line 628 "Settings.c"
		}
#line 161 "../src/Settings.vala"
		case SHORTCUT_KEY_CTRL:
#line 632 "Settings.c"
		{
			gchar* _tmp1_;
#line 165 "../src/Settings.vala"
			_tmp1_ = g_strdup ("<CTRL>");
#line 165 "../src/Settings.vala"
			result = _tmp1_;
#line 165 "../src/Settings.vala"
			return result;
#line 641 "Settings.c"
		}
#line 161 "../src/Settings.vala"
		case SHORTCUT_KEY_SHIFT:
#line 645 "Settings.c"
		{
			gchar* _tmp2_;
#line 167 "../src/Settings.vala"
			_tmp2_ = g_strdup ("<SHIFT>");
#line 167 "../src/Settings.vala"
			result = _tmp2_;
#line 167 "../src/Settings.vala"
			return result;
#line 654 "Settings.c"
		}
#line 161 "../src/Settings.vala"
		case SHORTCUT_KEY_SUPER:
#line 658 "Settings.c"
		{
			gchar* _tmp3_;
#line 169 "../src/Settings.vala"
			_tmp3_ = g_strdup ("<SUPER>");
#line 169 "../src/Settings.vala"
			result = _tmp3_;
#line 169 "../src/Settings.vala"
			return result;
#line 667 "Settings.c"
		}
#line 161 "../src/Settings.vala"
		case SHORTCUT_KEY_PRIMARY:
#line 671 "Settings.c"
		{
			gchar* _tmp4_;
#line 171 "../src/Settings.vala"
			_tmp4_ = g_strdup ("<PRIMARY>");
#line 171 "../src/Settings.vala"
			result = _tmp4_;
#line 171 "../src/Settings.vala"
			return result;
#line 680 "Settings.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 173 "../src/Settings.vala"
			_tmp5_ = g_strdup ("<ALT>");
#line 173 "../src/Settings.vala"
			result = _tmp5_;
#line 173 "../src/Settings.vala"
			return result;
#line 691 "Settings.c"
		}
	}
}

Settings*
settings_construct (GType object_type)
{
	Settings * self = NULL;
#line 39 "../src/Settings.vala"
	self = (Settings*) g_object_new (object_type, NULL);
#line 39 "../src/Settings.vala"
	return self;
#line 704 "Settings.c"
}

Settings*
settings_new (void)
{
#line 39 "../src/Settings.vala"
	return settings_construct (TYPE_SETTINGS);
#line 712 "Settings.c"
}

static void
settings_class_init (SettingsClass * klass,
                     gpointer klass_data)
{
#line 39 "../src/Settings.vala"
	settings_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = settings_finalize;
#line 723 "Settings.c"
}

static void
settings_instance_init (Settings * self,
                        gpointer klass)
{
}

static void
settings_finalize (GObject * obj)
{
	Settings * self;
#line 39 "../src/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS, Settings);
#line 39 "../src/Settings.vala"
	G_OBJECT_CLASS (settings_parent_class)->finalize (obj);
#line 740 "Settings.c"
}

static GType
settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Settings), 0, (GInstanceInitFunc) settings_instance_init, NULL };
	GType settings_type_id;
	settings_type_id = g_type_register_static (G_TYPE_OBJECT, "Settings", &g_define_type_info, 0);
	return settings_type_id;
}

GType
settings_get_type (void)
{
	static volatile gsize settings_type_id__once = 0;
	if (g_once_init_enter (&settings_type_id__once)) {
		GType settings_type_id;
		settings_type_id = settings_get_type_once ();
		g_once_init_leave (&settings_type_id__once, settings_type_id);
	}
	return settings_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

